/* CS 472/672 Assignment #3 - ilu.c file */

#include <stdio.h>   
#include "ilu.h"


/*                                  */
/* Incomplete Numeric factorization */
/*                                  */
void ilufac(int N, int *ia, int *ja, double *a, int *order, int *invord, struct sparse_row *ILU) 
/*
   input:

      N       number of unknowns
      ia, ja  stucture of a
      a       real values of a
      order   order[new_order] = old_order
      invord  invord[old_order] = new_order
      ILU     contains info about symbolic factors of the ILU 

   output:

      ILU     now contains real ILU as well as symbolic 
*/
{

   printf("You have to write the function ilufac.\n");
 
}


/*                */
/* Solve LU x = b */
/*                */
void ilusol(int N, double *x, double *b, int *order, struct sparse_row *ILU)
/*
   input:

      N      number of unknowns
      b      rhs
      order  order[new_order] = old_order
      ILU    sparse_row structure containing ILU

   output:

      x      solution in the original order
*/
{

   printf("You have to write the function ilusol.\n");

}


/*                       */
/* Symblic factorization */
/* (ilu approach)        */
/*                       */
void ilusym(int N, int *ia, int *ja, int *order, int *invord, struct sparse_row *ILU)
/* 
   input:

     N       number of unknowns
     ia, ja  structure of a
     order   order[new_order] = old_order
     invord  invord[old_order] = new_order
 
  output:

     ILU     sparse_row stucture contains symbolic ILU info
*/
{
   int i, k, iold, num;
 

   /* Allocate array of sparse_row structures for the LU matrix, */
   /* each structue points to a row.                             */

   /* Perform reordering */
   for (i=0; i<N; i++) {
      iold = order[i];
      num = ia[iold+1]-ia[iold];
      ILU[i].jaf = (int *) malloc(num*sizeof(int));
      ILU[i].af = (double *) malloc(num*sizeof(double));
      ILU[i].nz = num;

      for (k=ia[iold]; k<ia[iold+1]; k++) {
         ILU[i].jaf[k-ia[iold]] = invord[ja[k]];
      }
      if (num>1) sortq(ILU[i].jaf, 0, num-1); 

      k=0;
      while ((ILU[i].jaf[k]<i) & (k<num)) k++;
      ILU[i].diag=k;
      if (k==num) {
         printf("diagonal not found for row %d.\n",i);
         exit(0);
      }
   }

}


/*                      */
/* Auxilliary functions */
/*                      */

void shell(int *v, int n)
/*    
   shellsort: sort v[0], ..., v[*n_ptr-1] into increasing order
*/
{  
   int gap, i, j, temp;

   for (gap=n/2; gap>0; gap=gap/2) {
      for (i=gap; i<n; i++) {
         for (j=i-gap; j>=0 && v[j]>v[j+gap]; j=j-gap) {
            temp = v[j];
            v[j] = v[j+gap];
            v[j+gap] = temp;
         }
      }
   }
}


void swap(int *v, int i, int j)
/* 
   function used by sortq
*/
{
   int temp;

   temp = v[i];
   v[i] = v[j];
   v[j] = temp;
}


void sortq(int *v, int left, int right)
/* 
   simple quick sort 
*/
{
   int i, last, num_sort;

   num_sort = right - left + 1;

   if (num_sort<40) {
      shell( &v[left], num_sort);
      return;
   }

   if (left>=right) {
      return;
   }

   swap(v, left, (left + right)/2);

   last = left;

   for (i=left+1; i<=right; i++) {
      if (v[i]<v[left]) {
         swap(v, ++last, i);
      }
   }

   swap(v, left, last);

   sortq(v, left, last-1);
   sortq(v, last+1, right);
}


void clean(int N, struct sparse_row *ILU)
/*    
   Free space for ILU in after finished

   input:

     N   number of unknowns
     ILU  structure containing ILU

   output:

     ILU  structure deallocated
*/
{
    int    i;

    for (i=0; i<N; i++) {
       free(ILU[i].jaf);
       free(ILU[i].af);
    }
    free(ILU);
}

