/* CS 472/672 Assignment #3 - matrhs.c file */

#include <stdlib.h>
#include <math.h>
#include "matrhs.h"


/*
  imgmatrix creates the matrix for the denoising iteration.
*/
void imgmatrix(int n, double alpha, double *x, int *ia, int *ja, double *a)
{
  int i,j,l,k,kd,I;
  double a1,a2,a3,a4,a5,a6;
  double h,beta=1e-6;


  h=1.0/(n+1);
  ia[0] = 0;
  k = 0;
  for (j=0; j<n; j++) {
    for (i=0; i<n; i++) {

      I = j*n+i;

      /* bottom */
      if (j>0) {
        a1 = (x[I]-x[I-n])*(x[I]-x[I-n]);
        if (i>0) a1 += (x[I]-x[I-1])*(x[I]-x[I-1]);
        a1 = 1.0/(2*h*sqrt(a1+h*h*beta));
        a2 = (x[I]-x[I-n])*(x[I]-x[I-n]);
        if (i<n-1) a2 += (x[I+1-n]-x[I-n])*(x[I+1-n]-x[I-n]);
        a2 = 1.0/(2*h*sqrt(a2+h*h*beta));
        ja[k] = I-n; a[k] = -alpha*(a1+a2); k++;
      }

      /* left */
      if (i>0) {
        a1 = (x[I]-x[I-1])*(x[I]-x[I-1]);
        if (j>0) a1 += (x[I]-x[I-n])*(x[I]-x[I-n]);
        a1 = 1.0/(2*h*sqrt(a1+h*h*beta));
        a6 = (x[I]-x[I-1])*(x[I]-x[I-1]);
        if (j<n-1) a6 += (x[I+n-1]-x[I-1])*(x[I+n-1]-x[I-1]);
        a6 = 1.0/(2*h*sqrt(a6+h*h*beta));
        ja[k] = I-1; a[k] = -alpha*(a1+a6); k++;
      }

      /* center */
      ja[k] = I; a[k] = 0.0; kd=k; k++;

      /* right */
      if (i<n-1) {
        a3 = (x[I+1]-x[I])*(x[I+1]-x[I]);
        if (j>0) a3 += (x[I+1]-x[I+1-n])*(x[I+1]-x[I+1-n]);
        a3 = 1.0/(2*h*sqrt(a3+h*h*beta));
        a4 = (x[I+1]-x[I])*(x[I+1]-x[I]);
        if (j<n-1) a4 += (x[I+n]-x[I])*(x[I+n]-x[I]);
        a4 = 1.0/(2*h*sqrt(a4+h*h*beta));
        ja[k] = I+1; a[k] = -alpha*(a3+a4); k++;
      }

      /* top */
      if (j<n-1) {
        a4 = (x[I+n]-x[I])*(x[I+n]-x[I]);
        if (i<n-1) a4 += (x[I+1]-x[I])*(x[I+1]-x[I]);
        a4 = 1.0/(2*h*sqrt(a4+h*h*beta));
        a5 = (x[I+n]-x[I])*(x[I+n]-x[I]);
        if (i>0) a5 += (x[I+n]-x[I-1+n])*(x[I+n]-x[I-1+n]);
        a5  = 1.0/(2*h*sqrt(a5+h*h*beta));
        ja[k] = I+n; a[k] = -alpha*(a4+a5); k++;
      }

      for (l=ia[I]; l<k; l++) if (l != kd) a[kd] -= a[l];
      a[kd] += 1.0;

      ia[I+1] = k;
    }
  }

}


/*
  noisyimg creates a noisy image, stores the pixel values
  to the vector b, and initializes u to b.
*/
void noisyimg(int n,double *u,double *b)
{
  int    i,j,I,N;
  double h,x,y,r1,r2,b_norm;

  h=1.0/(n+1);
  for (j=1; j<=n; j++) {
    for (i=1; i<=n; i++) {

      I=(j-1)*n+i-1;

      /* exact image value */
      x=i*h; y=j*h;
      r1=sqrt((x-0.5)*(x-0.5)+(y-0.5)*(y-0.5));
      r2=sqrt((x-0.5)*(x-0.5)/2+(y-0.5)*(y-0.5));
      b[I]=0.0;
      if (r1<0.2) b[I] -= 0.5;
      if (r2<0.3) b[I] += 1.0;

    }
  }

  /* Add noise to b */
  b_norm=0.0;
  N=n*n;
  for (i=0; i<N; i++) b_norm += b[i]*b[i];
  b_norm=sqrt(b_norm);
  srand(42);
  for (i=0; i<N; i++) b[i] += 2*h*b_norm*(2.0*rand()/RAND_MAX-1);

  /* Copy b to u */
  for (i=0; i<N; i++) u[i] = b[i];

}

