/* CS472/672 Assignment #3 - matrhs.h file */

#ifndef MATRHS_H_INC
#define MATRHS_H_INC

/*
   This generates the noisy image linear system into ia, ja and a

   Input:
        n     = Number of nodes on one dimension of the grid.
                (N=n*n unknowns in the linear system.)
        alpha = Smoothing coefficient.

   Output:
        ia    = The array of row indices.
        ja    = The array of column indices.
         a    = The array of coefficients of the matrix.
*/

void imgmatrix(int n,double alpha,double *x,int *ia,int *ja,double *a);

/*
   This generates the RHS, b, and initializes x

   Input:
        n = Number of nodes on one dimension of the grid.
            (N=n*n unknowns in the linear system.)

   Output:
        b = RHS storing the pixel values of a noisy image.
        x = b
*/

void noisyimg(int n,double *x,double *b);


#endif

